1.1 The seed uses following algorithm: 
Random_Num_u32 = (Random_Num_u32 * (0x01C5A5035UL) + 1); 
The random number will be initialized as: 0x0B6951A59UL during program initialization phase. 
1.2 The key calculation algorithm is: 
/*********************************************************************** 
* Calc_Key(): Key Calc function 
 * \param Seed 
 * \return uint32 
 * \retval Key, calculated from seed. 
***********************************************************************/ 
uint32 Calc_Key(uint32 seed) 
{ 
	uint8 i = 0; 
	uint8 loops = 0; 
	 /* Calculatesthe key from a seed */ 
	 /* calculate the CRC checksum from the seed. Just to convert the seed to another value */ 
	SECA_SeedCRC_u16 = kwp2000_seed_crc ((uint8 *)&seed,(uint8 *)(&seed)+3); 
	 /* determine the number of loops depending on seed's crc value */ 
	loops = ((uint8) SECA_SeedCRC_u16 >>8)+((uint8)SECA_SeedCRC_u16 & 0xFF); 
	loops = (loops & 0x0F)+1; 
	for (i=0;i<loops;i++) 
	{
	//BITM was defined as: #define BITM(n,pos) ((((n>>(31-(pos&0xF)))&1)<<1)|((n>>(pos&0xF))&1)) 
	switch (BITM (seed, i)) 
	 { 
	case 0 : 
	 { 
	seed = (seed <<1)&0xFFFFFFFE; 
	seed ^= (~SECA_MaskCode_H_u32); 
	break; 
	 } 
	case 1 : 
	 { 
	seed += SECA_MaskCode_H_u32; 
	break; 
	 } 
	case 2 : 
	 { 
	seed = (seed <<1)|0x01; 
	seed ^= SECA_MaskCode_L_u32; 
	break; 
	 } 
	default : /* (3) */ 
	 { 
	seed += (~SECA_MaskCode_L_u32); 
	break; 
	 } 
	 } 
	 } 
	return seed; 
} 
uint16 kwp2000_seed_crc(uint8 *crcVarPtr,uint8 *crcEndPtr) 
{ 
	 uint8 i; 
	 uint16var; 
	 uint16 crc16_w = 0xFFEE; 
	 while(crcVarPtr<= crcEndPtr)
	{ 
	 var = ((uint16)*crcVarPtr++) << 8; 
	 for(i = 0; i < 8; i++) 
	 { 
	 if((crc16_w ^ var) & 0x8000) 
	 { 
	 crc16_w = (crc16_w << 1) ^ 0xA001; 
	 } 
	 else 
	 { 
	 crc16_w = crc16_w << 1; 
	 } 
	 var<<= 1; 
	 } 
	 } 
	return(crc16_w); 
} 
SECA_MaskCode_H_u32 = ((uint32)(0x34)<< 24) +((uint32)(0x34)<< 16) +((uint16)(0x34)<< 8) +(0x34); 
SECA_MaskCode_L_u32 = ((uint32)(0x34)<< 24) +((uint32)(0x34)<< 16) +((uint16)(0x34)<< 8) +(0x34); 